#! /bin/bash

trap "echo '*** BUILD FAILED! ***' 1>&2" ERR
set -ex -o pipefail
umask 022
export PATH='/bin:/usr/bin:/usr/local/bin:~/diet-pc/tools'
export CFLAGS=${CFLAGS:--Os}
export CXXFLAGS=${CXXFLAGS:--Os}

rebuild () {
    tar xzf xwChoice-1.14.tgz
    cd xwChoice-1.14
    bunzip2 -c ../xwChoice-1.14-dietpc-patch.bz2 | patch -p1 -b
    # The "CLAGS" typo is deliberate!
    make DEBUG='' CLAGS="$CFLAGS -Wall" XAWLIB=/usr/lib/libXaw.so.6
    strip -R .note -R .comment xwChoice
    mkdir -p ../xwchoice/bin
    cp xwChoice ../xwchoice/bin/
    cd ..
    rm -rf xwChoice-1.14
}

while read FN; do
    eval "[ -e $FN ] || rebuild"
done < MANIFEST

ARCH=`ipkg -V 0 print_architecture | tail -n 1 | cut -f2 -d' '`
for CTRLFILE in */CONTROL/control; do
    sed -i -e "s/__ARCH__/$ARCH/g" $CTRLFILE
    sudo ipkg-build -o root -g root `dirname $CTRLFILE`/..
done
